//*************************************************************************
#include <iostream>     //inclusion of support for doing input & output
#include <string>       //inclusion of support of the string class
#include <vector>       //inclusion of support of the vector class
#include <fstream>       //inclusion of support of file I/O
using namespace std;    //declare access to standard stuff like cin, cout


#include "baseClass.h" 
#include "childClassA.h" 
#include "childClassB.h" 




//*************************************************************************
//	A simple waiting function
//*************************************************************************
void wait()
{     char ch;
	  cout << endl << "******************************************************" << endl;
      cout << "Press c to continue" << endl;
      cin >> ch;
}




//*************************************************************************
//	The test function
//*************************************************************************
void test()
{     

 	//*************************************************************************
    //Observe the implicit calls to constructors of the base and the child classes
 	//*************************************************************************
      baseClass jacob("JACOB");
      wait();
      childClassA joseph("JOSEPH");
      wait();
      childClassB benjamin("BENJAMIN");
      wait();


 	//*************************************************************************
    //Observe (i) the implicit calls to constructors of the base and the child classes
	//	    (ii) basePtrVector as a vector of polymorphic pointers using type cast.
 	//*************************************************************************
     vector<baseClass *> basePtrVector;
     basePtrVector.push_back( (baseClass *) new childClassB("TIMOTHY") );
     wait();

	 basePtrVector.push_back( (baseClass *) new childClassA("PAUL")          );
     wait();

	 basePtrVector.push_back( (baseClass *) new childClassB("TITUS")         );
     wait();


 	//*************************************************************************
    //Observe and think about the effects of polymorphism and dynamic method binding here
  	//*************************************************************************
     for ( vector<baseClass *>::iterator i=basePtrVector.begin();
                  i < basePtrVector.end();
                  ++i
         )
     {     (*i)->output();
     }
     wait();



 	//*************************************************************************
    //Observe the implicit calls to the destructors of the base and the child classes
 	//*************************************************************************
      delete basePtrVector[0];
      wait();


 	//*************************************************************************
    //Think about the issue of memory leak here. Is there a memory leak at this pont.
 	//*************************************************************************
      basePtrVector.clear();


      cout << "... time spent in basePtrVector.clear() ..." << endl;
      wait();

}	




//*************************************************************************
//	The main function just call the test function
//*************************************************************************
int  main()
{
	test();
	cout << "This is the end of the call to the test function." << endl;
	//*************************************************************************
	//Observe the implicit calls to the destructors of the base and the child classes
	//Also think about the issue of memory leak here again.
	//*************************************************************************


	wait();
	cout << "This is the end of the main function." << endl;

	return 0;
}